#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <stdlib.h>
#include <mem.h>         /* MUST be included to use
                            double buffer */

#include "graphem.h"

/* show functions */
void s_double_buffer(void);
void s_plotpixel(void);
void s_hline_vline(void);
void s_draw_fill_box(void);
void s_text_functs(void);
void s_draw_line(void);

int main(void)
{
  set_mode(MODE13h);

  s_double_buffer();
  s_plotpixel();
  s_hline_vline();
  s_draw_fill_box();
  s_text_functs();
  s_draw_line();

  delete_buffer();

  set_mode(TEXT_MODE);

  return 1;

} /* main */

void s_double_buffer(void)
{
  if (!create_buffer())
  {
    set_mode(TEXT_MODE);
    printf ("Need more memory");
    exit(1);
  } /* if */

  blit_string_DB("create_buffer()",0,0,15);
  blit_string_DB("copy_buffer",0,10,15);
  blit_string_DB("delete_buffer()",0,20,15);

  copy_buffer;

  getch();

} /* s_double_buffer */

void s_plotpixel(void)
{
  int x,y;

  fillscr_DB(0);
  blit_string_DB("plotpixel_DB(x,y,color)",0,0,15);
  copy_buffer;
  getch();

  for(y=0;y<200;y++)
    for(x=0;x<320;x++)
      plotpixel_DB(x,y,(x+y)%256);
  copy_buffer;

  getch();

} /* plotpixel */

void s_hline_vline(void)
{
  int x,y;

  fillscr_DB(0);
  blit_string_DB("hline_DB(x1,x2,y,color)",0,0,15);
  blit_string_DB("vline_DB(y1,y2,x,color)",0,10,15);
  copy_buffer;
  getch();

  for (x=20;x<301;x+=20)
    for (y=20;y<200;y+=20)
    {
      hline_DB (20,300,y,9);
      vline_DB (20,180,x,9);
    } /* for y */
  copy_buffer;
  getch();
} /* hline,vline */

void s_draw_fill_box(void)
{
  int x,color;

  fillscr_DB(0);
  blit_string_DB("fillbox_DB(x1,y1,x2,y2,color)",0,0,15);
  blit_string_DB("draw_box_DB(x1,y1,width,hieght,color)",0,10,15);
  copy_buffer;
  getch();

  color=16;
  for (x=30;x<275;x+=25)
  {
    fillbox_DB(x,50,x+20,100,++color);
    draw_box_DB(x,110,20,50,color);
  } /* for x */
  copy_buffer;
  getch();
} /* draw_box, fillbox */

void s_text_functs(void)
{
  fillscr_DB(0);
  blit_string_DB("blit_char_DB(ch,x,y,color)",0,0,15);
  blit_string_DB("blit_string_DB(str,x,y,color)",0,10,15);
  grad_string_DB("grad_char_DB(ch,x,y,color,inc)",0,20,18,1);
  grad_string_DB("grad_string_DB(str,x,y,color,inc)",0,30,31,-1);
  copy_buffer;
  getch();

} /* blit/grad_char, blit/grad_string */

void s_draw_line(void)
{
  fillscr_DB(0);
  blit_string_DB("draw_line_DB(xo,yo,x1,y1,color)",0,0,15);
  copy_buffer;
  getch();

  while (!kbhit())
  {
    draw_line_DB (rand()%320,rand()%200,rand()%320,rand()%200,rand()%256);
    draw_line_DB (rand()%320,rand()%200,rand()%320,rand()%200,rand()%256);
    draw_line_DB (rand()%320,rand()%200,rand()%320,rand()%200,rand()%256);
    draw_line_DB (rand()%320,rand()%200,rand()%320,rand()%200,rand()%256);
    copy_buffer;
  } /* while */

  getch();

} /* s_draw_line */


