#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <stdlib.h>
#include <mem.h>

#include "graphem.h"

/* pcx file structure */
pcx pcx_file;

/* show functions */
void s_PCX_load(void);
void s_sprite(void);
void s_image(void);

int main(void)
{
  set_mode(MODE13h);

  create_buffer();

  s_PCX_load();
  s_sprite();
  s_image();

  delete_buffer();
  PCX_del((pcx_ptr)&pcx_file);

  set_mode(TEXT_MODE);

  return 1;

} /* main */

void s_PCX_load(void)
{
  FILE *fp;

  if (!PCX_init((pcx_ptr)&pcx_file))
  {
    set_mode(TEXT_MODE);
    printf ("Need more Memory");
    exit(1);
  } /* if */

  if ((fp=fopen("IMAGES.PCX","rb"))==NULL)
  {
    set_mode(TEXT_MODE);
    printf ("Images.pcx not found");
    exit(1);
  } /* if */
  fclose(fp);

  blit_string("Press a key",0,0,15);
  getch();

  PCX_load("images.pcx",(pcx_ptr)&pcx_file,1);

  PCX_put_DB((pcx_ptr)&pcx_file);
  copy_buffer;

  getch();

} /* PCX functions */

void s_sprite(void)
{
  sprite spr;
  clock_t start;         /* for delay */
  int done=0;

  fillscr_DB(0);

  SET_SPRITE_SIZE(16,16);
  sprite_init((sprite_ptr)&spr,4);

  sprite_PCX_get((sprite_ptr)&spr,(pcx_ptr)&pcx_file,0,0,0);
  sprite_PCX_get((sprite_ptr)&spr,(pcx_ptr)&pcx_file,1,1,0);
  sprite_PCX_get((sprite_ptr)&spr,(pcx_ptr)&pcx_file,2,2,0);
  sprite_PCX_get((sprite_ptr)&spr,(pcx_ptr)&pcx_file,3,3,0);

  blit_string_DB("SET_SPRITE_SIZE(x,y)",0,0,24);
  blit_string_DB("sprite_init((sprite_ptr)&spr)",0,10,24);
  blit_string_DB("sprite_PCX_get((sprite_ptr)&spr,",0,20,24);
  blit_string_DB("   (pcx_ptr)&pcxfile,frame,x,y)",0,30,24);
  blit_string_DB("behind_sprite((sprite_ptr)&spr)",0,40,24);
  blit_string_DB("draw_sprite((sprite_ptr)&spr)",0,50,24);
  blit_string_DB("erase_sprite_init((sprite_ptr)&spr)",0,60,24);
  blit_string_DB("sprite_delete((sprite_ptr)&spr)",0,70,24);
  blit_string_DB("Arrow keys move",0,90,24);
  blit_string_DB("Any other Key Exits",0,100,24);

  spr.x=150;
  spr.y=100;          /* initialize */
  spr.cur_frame=0;

  behind_sprite_DB((sprite_ptr)&spr);
  while (!done)
  {
    erase_sprite_DB((sprite_ptr)&spr);

    if (kbhit())
    {
      switch(getch())
      {
        case 0:break;
        case 72: spr.y-=5;break;          /* up */
        case 75: spr.x-=5;break;          /* left */
        case 77: spr.x+=5;break;          /* right */
        case 80: spr.y+=5;break;          /* down */
        default: done=1; break;
      } /* switch */
    } /* if */

    if (spr.x>303) spr.x=303;
    if (spr.y>183) spr.y=183;
    if (spr.x<0) spr.x=0;
    if (spr.y<0) spr.y=0;

    spr.cur_frame++;
    if (spr.cur_frame==4)
      spr.cur_frame=0;

    behind_sprite_DB((sprite_ptr)&spr);
    draw_sprite_DB((sprite_ptr)&spr);
    copy_buffer;

    start=clock()+75;
    while (clock()<start) {}          /* delay(75) */
    retrace;
  } /* while */

  sprite_delete((sprite_ptr)&spr);

} /* sprite functs */

void s_image(void)
{
  image img;
  clock_t start;
  int delay=0,done=0;

  fillscr_DB(0);
  blit_string_DB("image_init((image_ptr)&img,width,height)",0,0,24);
  blit_string_DB("image_PCX_get((image_ptr)&img,",0,10,24);
  blit_string_DB("   (pcx_ptr)&pcxfile,x,y)",0,20,24);
  blit_string_DB("image_get((image_ptr)&img,x,y)",0,30,24);
  blit_string_DB("image_put((image_ptr)&img,x,y)",0,40,24);

  blit_string_DB("Press 'd' to toggle delay",0,60,24);
  blit_string_DB("Any other Key Exits",0,70,24);

  copy_buffer;
  getch();

  image_init((image_ptr)&img,147,54);

  image_PCX_get((image_ptr)&img,(pcx_ptr)&pcx_file,125,22);

  fillscr_DB(0);
  while (!done)
  {
    image_put_DB((image_ptr)&img,rand()%163,rand()%145);

    if (kbhit())
      switch(getch())
      {
        case 'd':
        case 'D': delay=!delay; break;
        default: done=1;
      } /* switch */

    copy_buffer;
    if (delay)
    {
      start=clock()+50;
      while(clock()<start) {}
    } /* if */
  } /* while */

} /* image functs */



