#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <stdlib.h>

#include "graphem.h"

/* show functions */
void s_plotpixel(void);
void s_hline_vline(void);
void s_draw_fill_box(void);
void s_text_functs(void);
void s_fillscr(void);
void s_draw_line(void);
void s_setpal(void);
void s_fade_in_out(void);
void s_mouse(void);

int main(void)
{
  set_mode(MODE13h);

  s_plotpixel();
  s_hline_vline();
  s_draw_fill_box();
  s_text_functs();
  s_fillscr();
  s_draw_line();
  s_setpal();
  s_fade_in_out();
  s_mouse();

  set_mode(TEXT_MODE);

  return 1;

} /* main */

void s_plotpixel(void)
{
  int x,y;

  fillscr(0);
  blit_string("plotpixel(x,y,color)",0,0,15);
  getch();

  for(y=0;y<200;y++)
    for(x=0;x<320;x++)
      plotpixel(x,y,(x+y)%256);

  getch();

} /* plotpixel */

void s_hline_vline(void)
{
  int x,y;

  fillscr(0);
  blit_string("hline(x1,x2,y,color)",0,0,15);
  blit_string("vline(y1,y2,x,color)",0,10,15);
  getch();

  for (x=20;x<301;x+=20)
    for (y=20;y<200;y+=20)
    {
      hline (20,300,y,9);
      vline (20,180,x,9);
    } /* for y */

  getch();
} /* hline,vline */

void s_draw_fill_box(void)
{
  int x,color;

  fillscr(0);
  blit_string("fillbox(x1,y1,x2,y2,color)",0,0,15);
  blit_string("draw_box(x1,y1,width,hieght,color)",0,10,15);
  getch();

  color=16;
  for (x=30;x<275;x+=25)
  {
    fillbox(x,50,x+20,100,++color);
    draw_box(x,110,20,50,color);
  } /* for x */

  getch();
} /* draw_box, fillbox */

void s_text_functs(void)
{
  fillscr(0);
  blit_string("blit_char(ch,x,y,color)",0,0,15);
  blit_string("blit_string(str,x,y,color)",0,10,15);
  grad_string("grad_char(ch,x,y,color,inc)",0,20,18,1);
  grad_string("grad_string(str,x,y,color,inc)",0,30,31,-1);
  getch();

} /* blit/grad_char, blit/grad_string */

void s_fillscr(void)
{
  int a;

  fillscr(0);
  blit_string("fillscr(color)",0,0,15);
  getch();

  for (a=0;a<=255;a++)
    fillscr(a);

} /* fillscr */

void s_draw_line(void)
{
  fillscr(0);
  blit_string("draw_line(xo,yo,x1,y1,color)",0,0,15);
  getch();

  while (!kbhit())
    draw_line (rand()%320,rand()%200,rand()%320,rand()%200,rand()%256);

  getch();

} /* s_draw_line */

void s_setpal(void)
{
  int a,r=0,g=0,b=0;

  fillscr(0);
  grad_string("setpal(colornum,r,g,b)",0,0,18,1);
  grad_string("getpal(colornum,&r,&g,&b)",0,10,26,-1);
  getch();

  while (!kbhit())
  {
    for (a=18;a<=26;a++)
    {
      getpal (a,&r,&g,&b);
      if (b == 28)
      {
        b=4;r=4;g=4;
      } /* if */
      setpal (a,++r,++g,++b);
    } /* for a */
    retrace;                   /* vertical retrace */
  } /* while */

  getch();

} /* setpal,getpal */

void s_fade_in_out(void)
{
  int a,r,g,b,x,y;
  uchar __far *pal;

  pal=(uchar __far *)malloc(768);

  for(a=0;a<768;a+=3)
  {
    getpal(a,&r,&g,&b);
    pal[a]=(char)r;
    pal[a+1]=(char)g;
    pal[a+2]=(char)b;
  } /* for a */

  fillscr(0);
  blit_string("fade_out()",0,0,15);
  blit_string("fade_in(pal)",0,10,15);
  getch();

  fade_out();
  for(y=0;y<200;y++)
    for(x=0;x<320;x++)
      plotpixel(x,y,(x+y)%256);
  getch();
  fade_in(pal);

  getch();

  fade_out();
  fillscr(0);
  fade_in(pal);

  free(pal);

} /* fade_in,fade_out */

void s_mouse(void)
{
  mouseinit();

  mouseset(SHOW,0,0);

  blit_string("mouseinit()",0,0,15);
  blit_string("mouseset(SHOW,0,0)",0,10,15);
  blit_string("mouseset(HIDE,0,0)",0,20,15);
  blit_string("mouseset(H,min_x,max_x)",0,30,15);
  blit_string("mouseset(V,min_y,max_y)",0,40,15);
  blit_string("mouseset(POS,x,y)",0,50,15);

  getch();

  mouseset(HIDE,0,0);

} /* mouse functs */



